<div id="body" class="container-fluid">
  <h6>Vendor Model</h6>
  <form [formGroup]="form" novalidate>
    <div class="card bg-light mb-1">
      <div class="card-body">
        <h6>Vendor Model Form</h6>
        <div class="form-group form-group-sm row">
          <label for="manfList" class="col-4">Manufacturer:</label>
          <div class="col-10">
            <dx-select-box name="manfList" formControlName="manfList" [items]="manufacturerList"
                           placeholder="Select Manufacturer" [showClearButton]="true"
                           displayExpr="manfNme" valueExpr="manfId" required
                           [searchEnabled]="true" [searchExpr]="['manfNme']" searchMode="startswith"
                           (onSelectionChanged)="onManufacturerChanged($event)"></dx-select-box>
            <div *ngIf="manfList.invalid && (manfList.dirty || manfList.touched)">
              <span *ngIf="manfList.errors.required" class="form-text text-danger">
                Manufacturer is required
              </span>
            </div>
          </div>
          <div class="col-10">
            <button class="btn btn-sm btn-secondary" type="button" (click)="alter()">
              <span id="manfAlterButton">Alter Manufacturer List</span>
              <span id="manfCloseButton" style="display: none">Close</span>
            </button>
          </div>
        </div>
        <div class="form-group form-group-sm row" id="manfDiv" style="display: none">
          <label for="manufacturerName" class="col-4">Manufacturer Name:</label>
          <div class="col-10">
            <input #manufacturerName name="manufacturerName" type="text" class="form-control form-control-sm"
                   placeholder="Manufacturer Name" formControlName="manufacturerName" />
          </div>
          <div class="col-10">
            <div class="row">
              <div class="col-12">
                <button class="btn btn-sm btn-primary btn-block" type="button" (click)="addManufacturer()">
                  Add Manufacturer
                </button>
              </div>
              <div class="col-12">
                <button class="btn btn-sm btn-secondary btn-block" type="button" (click)="removeManufacturer()">
                  Remove Manufacturer
                </button>
              </div>
            </div>
          </div>
        </div>
        <div class="form-group form-group-sm row">
          <label for="txtDevModel" class="col-4">Device Model:</label>
          <div class="col-10">
            <input name="txtDevModel" class="form-control form-control-sm" formControlName="txtDevModel"
                   placeholder="Device Model" type="text" required />
            <div *ngIf="txtDevModel.invalid && (txtDevModel.dirty || txtDevModel.touched)">
              <span *ngIf="txtDevModel.errors.required" class="form-text text-danger">
                Device Model is required
              </span>
              <span *ngIf="txtDevModel.errors.maxLength" class="form-text text-danger">
                Maximum of 50 characters
              </span>
            </div>
          </div>
        </div>
        <div class="form-group form-group-sm row">
          <label for="txtDuration" class="col-4">Duration:</label>
          <div class="col-10">
            <input name="txtDuration" class="form-control form-control-sm" formControlName="txtDuration"
                   placeholder="Duration" type="number" min="0" required />
            <div *ngIf="txtDuration.invalid && (txtDuration.dirty || txtDuration.touched)">
              <span *ngIf="txtDuration.errors.required" class="form-text text-danger">
                Duration is required
              </span>
            </div>
          </div>
        </div>
        <div class="form-group form-group-sm row">
          <label for="txtDuration" class="col-4">Status:</label>
          <div class="col-10">
            <dx-check-box name="chkStatus" formControlName="chkStatus"></dx-check-box>
          </div>
        </div>
        <div class="form-group form-group-sm row">
          <div class="col-4"></div>
          <div class="col-10">
            <div class="row">
              <div class="col-12">
                <button class="btn btn-sm btn-primary btn-block" type="button" (click)="onSubmit()">
                  Save
                </button>
              </div>
              <div class="col-12">
                <button class="btn btn-sm btn-secondary btn-block" type="button" (click)="clearForm()">
                  Cancel
                </button>
              </div>
            </div>
          </div>
          <div class="col-10">
            <dx-check-box name="chkRemember" text="Remember Manufacturer selection" formControlName="chkRemember"
                          (onValueChanged)="valueChangedHandler($event)"></dx-check-box>
          </div>
        </div>
      </div>
    </div>
  </form>

  <dx-data-grid #grid id="grid" [dataSource]="items" keyExpr="devModelId" [wordWrapEnabled]="true"
                [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                (onSelectionChanged)="selectionChangedHandler($event)"
                (onToolbarPreparing)="onToolbarPreparing($event)"
                (onContentReady)="grid.instance.searchByText(grid.searchPanel.text.trim())"
                (onCellClick)="onEditingStart($event)">
    <dxo-sorting mode="multiple"></dxo-sorting>
    <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
    <dxo-header-filter [visible]="true"></dxo-header-filter>
    <dxo-filter-panel [visible]="true"></dxo-filter-panel>
    <dxo-paging [pageSize]="50"></dxo-paging>
    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
    <dxo-search-panel [visible]="true" [highlightCaseSensitive]="true"></dxo-search-panel>
    <dxi-column type="buttons" headerCellTemplate="editHeaderTemplate" [minWidth]="50">
      <dxi-button hint="Edit" icon="edit" [onClick]="loadEditForm"></dxi-button>
    </dxi-column>
    <dxi-column dataField="manfId" caption="Manufacturer"
                [allowHeaderFiltering]="true" [minWidth]="150">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxo-lookup [dataSource]="manufacturerList" valueExpr="manfId" displayExpr="manfNme">
      </dxo-lookup>
    </dxi-column>
    <dxi-column dataField="devModelNme" caption="Device Model" dataType="string"
                [allowHeaderFiltering]="false" [minWidth]="150">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxi-validation-rule type="stringLength" [max]="50"
                           message="Device Model max characters is 50."></dxi-validation-rule>
    </dxi-column>
    <dxi-column dataField="minDrtnTmeReqrAmt" caption="Duration" dataType="number"
                [allowHeaderFiltering]="false" alignment="left" [minWidth]="100">
      <dxi-validation-rule type="required"></dxi-validation-rule>
    </dxi-column>
    <dxi-column dataField="recStatus" caption="Status" dataType="boolean" [allowHeaderFiltering]="false"></dxi-column>
    <dxi-column dataField="createdByAdId" caption="Created By" dataType="string"
                [allowHeaderFiltering]="false" [minWidth]="100"></dxi-column>
    <dxi-column dataField="modifiedByAdId" caption="Modified By" dataType="string"
                [allowHeaderFiltering]="false" [minWidth]="100"></dxi-column>
    <dxi-column dataField="modfdDt" cellTemplate="localStartTime" caption="Modified Date"
                dataType="string" [allowHeaderFiltering]="false" [minWidth]="150"></dxi-column>
    <div *dxTemplate="let cell of 'localStartTime'">
      <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
    </div>
    <div *dxTemplate="let data of 'editHeaderTemplate'">
      <div>Edit</div>
    </div>
    <div *dxTemplate="let data of 'removeTemplate'">
      <button class="btn btn-sm btn-primary" type="button"
              [disabled]="!selectedItemKeys.length" (click)="deleteRows()">
        Remove Selected Records
      </button>
    </div>
  </dx-data-grid>
</div>
